class FilterRequestFields {
    constructor(queryName, filter) {
        this.queryName = queryName;
        this.filter = filter;
        this.skipFields = new Set(['__typename']);
    }

    transformRequest(request) {
      request.document.definitions.find(
        def=>def.kind === "OperationDefinition"
      ).selectionSet.selections.find(
        (selection)=>selection.name.value === this.queryName
      ).selectionSet.selections.forEach((node)=>{
        if (!this.filter(node.name.value) && !this.skipFields.has(node.name.value)) {
          node.name.value = null;
        }
      });
      return request;
    }
}

module.exports = {
  FilterRequestFields
}