'use strict'
/**
 * A map of the type of loyalty plus events which can be submitted to the LoyaltyPlus system.
 *
 * @constant
 * @type {Object<string, string>}
 */
const EVENT_TYPES = {
    'CHALLENGE': 'raise_challenge',
    'FOLLOW': 'raise_follow',
    'LAB': 'raise_lab',
    'LIKE': 'raise_image_like',
    'UPLOAD': 'raise_image_upload'
}

/**
 * A map of the type of loyalty plus requests which can be submitted to the LoyaltyPlus system.
 *
 * @constant
 * @type {Object<string, string>}
 */
const REQUEST_TYPES = {
    'DEACTIVATE': 'deactivate',
    'ENROLL': 'enroll',
    'RECORD': 'record',
    'UPDATE': 'update'
}

module.exports = {
    EVENT_TYPES,
    REQUEST_TYPES
}
