'use strict';

// Like Node's util.promisify, but it leaves the method bound to its owning
// object by taking the owning object and dereferencing the method itself.
// Apparently, Node's promisify is already supposed to work this way, but it
// doesn't when I try it sometimes, so.
function boundPromisify(object, methodName) {
    return (...args) => new Promise((t, c) =>
        object[methodName](...args, (err, res) => err ? c(err) : t(res)));
}

module.exports = {
  boundPromisify
};
