let logger = require('./../libs/logger').getLogger(module);

function wrapTimer(fn, label) {
  return async function (...args) {
      const start = new Date()
      const result = await fn(...args)
      const end = new Date()
      const duration = (end-start) / 1000
      return result;
  }
}

module.exports = {
  wrapTimer
}