// DEPRECATED: Use gql-requester.js instead

// Only lets you go one level deep at the moment (ie, you can't do something
// like photo{ owner{ name } }), but most of our tests deliberately focus on
// one 'endpoint' at a time.

'use strict';

const {request} = require('graphql-request');

function filterUndefined(obj) {
    return Object.entries(obj).reduce(
        // Filter out any explicit undefineds
        (o, [k, v]) => v === undefined ? o : {...o, [k]: v},
        {}
    );
}

function mergeFields(defaults, fields) {
    let merged = Array.from(new Set([...defaults, ...fields]));
    return merged.length > 0 ? `{ ${merged.sort().join(' ')} }` : '';
}

function mergeParams(defaults, params) {
    let merged = filterUndefined({...defaults, ...params});
    return Object.keys(merged).length > 0 ? `( ${toGql(merged)} )` : '';
}

function buildRequester(
    url, type, name, defaultParams = {}, defaultFields = []
) {
    return function requester(params = {}, fields = []) {
        return request(
            url,
            `
                ${type} {
                    ${name}
                    ${mergeParams(defaultParams, params)}
                    ${mergeFields(defaultFields, fields)}
                }
            `.replace(/\s+/g, ' ')
        );
    };
}

function toGql(params) {
    let coerceValue = v => {
        // Quote strings, call toString() (via ${}) on everything else
        if (
            typeof v === 'string'
            || v instanceof String
        ) return `"${v}"`;

        else if (
            typeof v === 'number'
            || v instanceof Number
            || v instanceof Boolean
            || v === null
        ) return `${v}`;

        else {
            let err = new TypeError();
            err.object = v;
            throw err;
        }
    };

    return Object.keys(params).sort().reduce(
        (a, k) => a.concat(`${k}: ${coerceValue(params[k])}`),
        []
    ).join(', ');
}

module.exports = buildRequester;
