const blackList = require('../libs/black-list');

function applyValidation(ModelClass, fields, validatorFn, options) {
    for (const field of fields) {
        ModelClass.validate(field, validatorFn({field}), options);
    }
}

function validatesVocabulary(options) {
    return function (err) {
        const value = this[options.field];
        if (!value) {
            return
        }
        if (blackList.isBlacklisted(value)) {
            err();
        }
    }
}

function preventActionIfLR(photo, uploadSource = '') {
    // To prevent certain actions, like tag edits, for lightroom images
    if (!photo) return;
    if (
        (!uploadSource && (photo.uploadSource || '').toLowerCase() === 'lightroom')
        || (uploadSource && uploadSource.toLowerCase !== 'lightroom')
    ) {
        throw `Photo with ID ${photo.id} cannot be edited because it was uploaded from lightroom.`;
    }
}

module.exports = {
    applyValidation,
    validatesVocabulary,
    preventActionIfLR
};
